//+------------------------------------------------------------------+
//|                                                Google_Charts.mqh |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2010, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"

#include <Strings\String.mqh>
#include <Arrays\ArrayDouble.mqh>
#include <Arrays\ArrayInt.mqh>
#include <Arrays\ArrayString.mqh>
#include <Files\FileBin.mqh>

#import "ColorToText.dll"
//+------------------------------------------------------------------+
//       
// R -   
// G -   
// B -   
// :    16- 
//+------------------------------------------------------------------+
string ColorToTxt(int R, int G, int B);
#import "PNG_to_BMP.dll"// DLL    PNG   BMP
//+------------------------------------------------------------------+
//  PNG  BMP
// src -    
// dst -    
// : true-, false-
//+------------------------------------------------------------------+
bool Convert_PNG(string src, string dst);
#import "wininet.dll"// DLL      
//+------------------------------------------------------------------+
//         (Windows API)     
// x - ,     0
// : 0-  ,   
//+------------------------------------------------------------------+
int InternetAttemptConnect(int x);
//+------------------------------------------------------------------+
//      WinInet (Windows API)   
// sAgent -  ,  
// lAccessType -  
// sProxyName -  -
// sProxyBypass -   
// lFlags -  
// :     , NULL   
//+------------------------------------------------------------------+
int InternetOpenW(string sAgent,int lAccessType,
                  string sProxyName="",string sProxyBypass="",
                  int lFlags=0);
//+------------------------------------------------------------------+
//    (Windows API)   
// hInternetSession -  
// sUrl -  
// sHeaders - 
// lHeadersLength -  
// lFlags -  
// :  , NULL   
//+------------------------------------------------------------------+                  
int InternetOpenUrlW(int hInternetSession,string sUrl,
                     string sHeaders="",int lHeadersLength=0,
                     int lFlags=0,int lContext=0);
//+------------------------------------------------------------------+
// ,      (Windows API)   
// hFile -  
// sBuffer -     
// lNumBytesToRead -   
// lNumberOfBytesRead -    
// :  , NULL   
//+------------------------------------------------------------------+                       
int InternetReadFile(int hFile,char &sBuffer[],int lNumBytesToRead,
                     int &lNumberOfBytesRead[]);
//+------------------------------------------------------------------+
//   (Windows API)   
// hInet -  
// : 0-  ,   
//+------------------------------------------------------------------+                          
int InternetCloseHandle(int hInet);
#import "kernel32.dll"
//+------------------------------------------------------------------+
//   (Windows API)    
// path -   
// : true-, false-
//+------------------------------------------------------------------+
bool DeleteFileW(string path);
#import
//+------------------------------------------------------------------+
//       
//+------------------------------------------------------------------+
enum DIAGRAM_TYPE
{
   ///
   DIAGRAM_TYPE_BASE=0, 
   /// 
   DIAGRAM_TYPE_LINEXY=1, 
   ///
   DIAGRAM_TYPE_FORMULA=2, 
   ///
   DIAGRAM_TYPE_BAR=3, 
   ///
   DIAGRAM_TYPE_PIE=4,
   ///
   DIAGRAM_TYPE_GRAPH=5,
   ///
   DIAGRAM_TYPE_RADAR=6,
   ///QR 
   DIAGRAM_TYPE_QRCODE=7,
   ///
   DIAGRAM_TYPE_VENN=8,
   /// 
   DIAGRAM_TYPE_CANDLESTRICK=9,
   ///
   DIAGRAM_TYPE_SCATTER=10,
   ///
   DIAGRAM_TYPE_MAP=11
};
//+------------------------------------------------------------------+
// ,  
//:       GetLastError() 
//+------------------------------------------------------------------+
enum DIAGRAM_ERR
{
   /// 
   DIAGRAM_NO_ERR=1,
   ///     
   DIAGRAM_ERR_INCORRECT_DATA_AMOUNT=2,
   ///    
   //:      OBJ_BITMAP  OBJ_BITMAP_LABEL
   DIAGRAM_ERR_INCORRECT_OBJ_TYPE=3,
   ///   
   DIAGRAM_ERR_OBJ_NOT_EXIST=4,
   ///  
   //:    ,    
   DIAGRAM_ERR_INCORRECT_LINE_ID=5,
   ///   
   DIAGRAM_ERR_INVALID_FILLING_TYPE=6,
   ///  
   ///. DIAGRAM_LINE_MARKERS
   DIAGRAM_ERR_INVALID_MARKER_TYPE=7,
   ///     
   DIAGRAM_ERR_INCORRECT_FILL_INDEX=8,
   ///  
   //:    - 100
   DIAGRAM_ERR_TOO_MANY_LINES=9,
   ///  
   DIAGRAM_ERR_IMAGE_CONVERSION_FAILED=10, 
   ///   
   DIAGRAM_ERR_INTERNET_CONNECT_FAILED=11,
   ///  
   //:    - 100
   DIAGRAM_ERR_TOO_MANY_LABELS=12,
   ///  
   ///. DIAGRAM_LABELS_TYPE
   DIAGRAM_ERR_INVALID_LABEL_TYPE=13,
   ///  
   //:    ,    
   DIAGRAM_ERR_INCORRECT_LABEL_ID=14,
   ///    
   //:    - 100
   DIAGRAM_ERR_TOO_MANY_EDGES=15,
   ///  
   //:    - 100   
   DIAGRAM_ERR_TOO_MANY_NODES=16,
   ///  
   //:    ,    
   DIAGRAM_ERR_INCORRECT_NODE_ID=17,
   ///  
   //:    ,       
   DIAGRAM_ERR_INCORRECT_EDGE_ID=18,
   ///   (. -2048)
   //:    ,         ...
   DIAGRAM_ERR_TOO_LARGE_REQUEST=19
};
//+------------------------------------------------------------------+
//   CQRCodeChrat
//+------------------------------------------------------------------+
enum DIAGRAM_QRCODE_ENCODING
{
   DIAGRAM_QRCODE_ENCODING_UTF_8=1,
   DIAGRAM_QRCODE_ENCODING_Shift_JIS=2,
   DIAGRAM_QRCODE_ENCODING_ISO_8859_1=3
};
//+------------------------------------------------------------------+
//     CQRCodeChrat
//+------------------------------------------------------------------+
enum DIAGRAM_QRCODE_ERROR_CORRECTION
{
   DIAGRAM_QRCODE_ERROR_CORRECTION_LOW=1,
   DIAGRAM_QRCODE_ERROR_CORRECTION_MEDIUM=2,
   DIAGRAM_QRCODE_ERROR_CORRECTION_HIGH=3,
};
//+------------------------------------------------------------------+
//     CGraphChrat
//+------------------------------------------------------------------+
enum DIAGRAM_GRAPH_ENGINES
{
   DIAGRAM_GRAPH_ENGINE_DOT=1,
   DIAGRAM_GRAPH_ENGINE_NEATO=2,
   DIAGRAM_GRAPH_ENGINE_TWOPI=3,
   DIAGRAM_GRAPH_ENGINE_CIRCO=4,
   DIAGRAM_GRAPH_ENGINE_FDP=5
};
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
enum DIAGRAM_AXIS
{
   ///X-
   DIAGRAM_AXIS_BOTTOM=1,
   /// 
   DIAGRAM_AXIS_TOP=2,
   ///Y-
   DIAGRAM_AXIS_LEFT=4,
   /// 
   DIAGRAM_AXIS_RIGHT=8
};
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
enum DIAGRAM_LEGEND_POSITION
{
   DIAGRAM_LEGEND_POSITION_RIGHT_VERTICAL=1,
   DIAGRAM_LEGEND_POSITION_BOTTOM_HORIZONTAL=2,
   DIAGRAM_LEGEND_POSITION_BOTTOM_VERTICAL=3,
   DIAGRAM_LEGEND_POSITION_TOP_HORIZONTAL=4,
   DIAGRAM_LEGEND_POSITION_TOP_VERTICAL=5,
   DIAGRAM_LEGEND_POSITION_LEFT_VERTICAL=6
};
//+------------------------------------------------------------------+
//   
//+------------------------------------------------------------------+
enum DIAGRAM_LINE_MARKERS
{
   DIAGRAM_LINE_MARKERS_ARROW=1,
   DIAGRAM_LINE_MARKERS_CROSS=2,
   DIAGRAM_LINE_MARKERS_DIAMOND=3,
   DIAGRAM_LINE_MARKERS_CIRCLE=4,
   DIAGRAM_LINE_MARKERS_SQARE=5
};
//+------------------------------------------------------------------+
//  
//+------------------------------------------------------------------+
enum DIAGRAM_LABELS_TYPE      
{
   DIAGRAM_LABEL_TYPE_FLAG=1,
   DIAGRAM_LABELS_TYPE_TEXT=2,
   DIAGRAM_LABELS_TYPE_ANNOTATION=3      
};
//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+
enum DIAGRAM_LABELS_HORIZONTAL_PLACEMENT
{
   DIAGRAM_LABELS_HORIZONTAL_PLACEMENT_LEFT=1,
   DIAGRAM_LABELS_HORIZONTAL_PLACEMENT_CENTER=2,
   DIAGRAM_LABELS_HORIZONTAL_PLACEMENT_RIGHT=3
};
//+------------------------------------------------------------------+
//    
//+------------------------------------------------------------------+
enum DIAGRAM_LABELS_VERTICAL_PLACEMENT
{
   DIAGRAM_LABELS_VERTICAL_PLACEMENT_BOTTOM=1,
   DIAGRAM_LABELS_VERTICAL_PLACEMENT_MIDDLE=2,
   DIAGRAM_LABELS_VERTICAL_PLACEMENT_TOP=3
};
//+------------------------------------------------------------------+
//   CMapChart
//+------------------------------------------------------------------+
enum DIAGRAM_MAP_AREA
{
   DIAGRAM_MAP_AREA_WORLD=0,
   DIAGRAM_MAP_AREA_AFRICA=1,
   DIAGRAM_MAP_AREA_ASIA=2,
   DIAGRAM_MAP_AREA_EUROPE=3,
   DIAGRAM_MAP_AREA_MIDDLE_EAST=4,
   DIAGRAM_MAP_AREA_SOUTH_AMERICA=5,
   DIAGRAM_MAP_AREA_USA=6
};
//+------------------------------------------------------------------+
//    
// Color - 
// :      16-  
//+------------------------------------------------------------------+
string GetColorStr(color Color)
{
   CString res;
   string R, G, B;
   res.Assign(ColorToString(Color));  
   int first=res.Find(0, ",");
   int last=res.FindRev(",");
   R=(res.Left(first));
   G=(res.Mid(first+1, last-first-1));
   B=(res.Right(res.Len()-last-1));
   return ColorToTxt(R, G, B);
}
//+------------------------------------------------------------------+
//     
// str - 
// new_str - 
// :    
//+------------------------------------------------------------------+
string Remove_spaces(string str, string new_str="+")
{
   CString res;
   res.Append(str);
   res.Replace(" ", new_str);
   return res.Str();
}
//+------------------------------------------------------------------+
//\class CDiagram
//\brief      
//+------------------------------------------------------------------+
class CDiagram 
{
protected:
   long chart_ID;
   string name;
   long obj_type;
   int X;
   int Y;
   string title;
   color title_color;
   int title_font_size;
   int legend_position;
   int margin_left;
   int margin_right;
   int margin_top;
   int margin_bottom;
   int legend_width_;
   int legend_height_;
   color fill_chart;
   color fill_bg;
public:
   bool Attach(long _chart_ID, string _name);
   bool Deatch();
   bool ObjExist();
   bool ObjExist(long _chart_ID, string _name);
   bool GetChart();
   void SetSize(int X_size, int Y_size);
   void SetTitle(string text, color color_, int font_size);
   //+------------------------------------------------------------------+
   // 
   // position   - 
   //+------------------------------------------------------------------+
   void ShowLegend(DIAGRAM_LEGEND_POSITION position=DIAGRAM_LEGEND_POSITION_RIGHT_VERTICAL) 
      {legend_position=position;}
   //+------------------------------------------------------------------+
   // 
   //+------------------------------------------------------------------+      
   void HideLegend() {legend_position=0;}
   void SetMargins(int left, int right, int top, int bottom, int legend_width, int legend_height);
   //+------------------------------------------------------------------+
   //   
   // chart   -  
   // background   -   
   //+------------------------------------------------------------------+
   void SetFill(color chart, color background=White) {fill_chart=chart; fill_bg=background;}
   void CDiagram();
   //+------------------------------------------------------------------+
   //      Google
   // :     
   //+------------------------------------------------------------------+   
   virtual string CreateRequest() {return "";} 
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+      
   virtual DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_BASE;}
};
//+------------------------------------------------------------------+
//     
//+------------------------------------------------------------------+
void CDiagram::CDiagram()
{
   X=300;
   Y=300;
   name="";
   title="";
   title_color=Black;
   title_font_size=0;
   legend_position=0;
   fill_chart=-1;
   fill_bg=-1;
}
//+------------------------------------------------------------------+
//  
// X_size   -
// Y_size   -
//:     ( CMapChart) 1000x1000 ,       
//:      CMapChart 440x220 ,       
//:        300000 ,         1000x300  
//+------------------------------------------------------------------+
void CDiagram::SetSize(int X_size, int Y_size)
{
   X=X_size; Y=Y_size;
   if(X>1000) X=1000;//  
   if(Y>1000) Y=1000;//    
   if(X<1) X=1;// 
   if(Y<1) Y=1;
   if(X*Y>300000) {X=1000; Y=300;}//   
}
//+------------------------------------------------------------------+
//      
// left   -   
// right   -   
// top   -   
// bottom   -   
// legend_width   - 
// legend_height   - 
//:    
//+------------------------------------------------------------------+
void CDiagram::SetMargins(int left, int right, int top, int bottom, int legend_width=0, int legend_height=0)
{
   margin_left=left;
   margin_right=right;
   margin_top=top;
   margin_bottom=bottom;
   legend_width_=legend_width;
   legend_height_=legend_height;
}
//+------------------------------------------------------------------+
//  
// text   - 
// color_   -  
// font_size   -  
//+------------------------------------------------------------------+
void CDiagram::SetTitle(string text, color color_=Black, int font_size=10)
{
   title=Remove_spaces(text, "+");
   title_color=color_;
   title_font_size=font_size;
}
//+------------------------------------------------------------------+
//    ,    
// : true- , false- 
//+------------------------------------------------------------------+
bool CDiagram::ObjExist()
{
   return (ObjectFind(chart_ID, name)>=0);
}
//+------------------------------------------------------------------+
//     
// _chart_ID   - 
// _name   - 
// : true- , false- 
//+------------------------------------------------------------------+
bool CDiagram::ObjExist(long _chart_ID, string _name)
{
   return (ObjectFind(_chart_ID, _name)>=0);
}
//+------------------------------------------------------------------+
//    
// _chart_ID   - 
// _name   - 
// : true-, false- 
//:      ,    GetLastError()
//+------------------------------------------------------------------+
bool CDiagram::Attach(long _chart_ID, string _name)
{
   if(!ObjExist(_chart_ID, _name)) 
      {SetUserError(DIAGRAM_ERR_OBJ_NOT_EXIST); return false;}
   obj_type=ObjectGetInteger(_chart_ID, _name, OBJPROP_TYPE);
   if(obj_type!=OBJ_BITMAP && obj_type!=OBJ_BITMAP_LABEL)
      {SetUserError(DIAGRAM_ERR_INCORRECT_OBJ_TYPE); return false;}
   chart_ID=_chart_ID;
   name=_name;
   return true;
}
//+------------------------------------------------------------------+
//    
// : true-, false- 
//:      ,    GetLastError()
//+------------------------------------------------------------------+
bool CDiagram::Deatch()
{
   CString src;
   src.Assign(TerminalInfoString(TERMINAL_DATA_PATH));
   src.Append("\MQL5\Files\\"+name+".png");
   src.Replace("\\","\\\\");
   CString dst;
   dst.Assign(TerminalInfoString(TERMINAL_DATA_PATH));
   dst.Append("\MQL5\Images\\"+name+".bmp");
   dst.Replace("\\","\\\\");
   DeleteFileW(dst.Str());
   DeleteFileW(src.Str());
   if(!ObjExist()) {SetUserError(DIAGRAM_ERR_OBJ_NOT_EXIST); return false;}   
   switch (obj_type)
   {
      case OBJ_BITMAP: 
      {
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, ""); 
         return true;
      }
      case OBJ_BITMAP_LABEL:
      {
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, 0, ""); 
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, 1, ""); 
         return true;
      }
      default: return false;
   }
   name="";
   chart_ID=-1;
   ChartRedraw();
   return true;
}
//+------------------------------------------------------------------+
//    Google       
// : true-, false- 
//:      ,    GetLastError()
//+------------------------------------------------------------------+
bool CDiagram::GetChart()
{
   if(!ObjExist()) {SetUserError(DIAGRAM_ERR_OBJ_NOT_EXIST); return false;}
   string request=CreateRequest();
   //Print(request);
   if(StringLen(request)>2048) {SetUserError(DIAGRAM_ERR_TOO_LARGE_REQUEST); return false;}
//  
   int rv=InternetAttemptConnect(0);
   if(rv!=0) {SetUserError(DIAGRAM_ERR_INTERNET_CONNECT_FAILED); return false;}
// 
   int hInternetSession=InternetOpenW("Microsoft Internet Explorer", 0, "", "", 0);
   if(hInternetSession<=0) {SetUserError(DIAGRAM_ERR_INTERNET_CONNECT_FAILED); return false;}
// 
   int hURL=InternetOpenUrlW(hInternetSession, request, "", 0, 0, 0);
   if(hURL<=0) SetUserError(DIAGRAM_ERR_INTERNET_CONNECT_FAILED);
//    
   CString src;
   src.Assign(TerminalInfoString(TERMINAL_PATH));
   src.Append("\MQL5\Files\\"+name+".png");
   src.Replace("\\","\\\\");
   CString dst;
   dst.Assign(TerminalInfoString(TERMINAL_PATH));
   dst.Append("\MQL5\Images\\"+name+".bmp");
   dst.Replace("\\","\\\\");
   DeleteFileW(dst.Str());
   DeleteFileW(src.Str());
   CFileBin chart_file;//,   
                       // 
   chart_file.Open(name+".png",FILE_BIN|FILE_WRITE);
   //****************************   
   int dwBytesRead[1];// -  
   char readed[1000];// 
                     // ,     
   while(InternetReadFile(hURL,readed,1000,dwBytesRead))
     {
      if(dwBytesRead[0]<=0) break;//  - 
      chart_file.WriteCharArray(readed,0,dwBytesRead[0]);//   
     }
   InternetCloseHandle(hInternetSession);// 
   chart_file.Close();// 
// 
   if(!Convert_PNG(src.Str(), dst.Str())) SetUserError(DIAGRAM_ERR_IMAGE_CONVERSION_FAILED);
//    
   switch (obj_type)
   {
      case OBJ_BITMAP: 
      {
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, name+".bmp"); 
         return true;
      }
      case OBJ_BITMAP_LABEL:
      {
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, 0, name+".bmp"); 
         ObjectSetString(chart_ID, name, OBJPROP_BMPFILE, 1, name+".bmp"); 
         return true;
      }
      default: return false;
   }
//    
   ChartRedraw();
}
//+------------------------------------------------------------------+
//\class CLineXYChart
//\brief     
//:   CDiagram  
//+------------------------------------------------------------------+
class CLineXYChart : public CDiagram
{
protected:
   int total_lines;
   int total_labels;
   int axes;
   double xmax_val, xmin_val;
   double ymax_val, ymin_val;
   double bottom_axe_step; 
   double top_axe_step;
   double left_axe_step;
   double right_axe_step;
   int bottom_axe_line;
   int top_axe_line;
   int left_axe_line;
   int right_axe_line;
   bool grid;
   double grid_x, grid_y;
   string bottom_axe_label;
   string top_axe_label;
   string left_axe_label;
   string right_axe_label;
   int bottom_axe_index;
   int top_axe_index;
   int left_axe_index;
   int right_axe_index;
   color bottom_axe_color;
   color top_axe_color;
   color left_axe_color;
   color right_axe_color;
   int bottom_axe_size;
   int top_axe_size;
   int left_axe_size;
   int right_axe_size;
   int bottom_axe_digits;
   int top_axe_digits;
   int left_axe_digits;
   int right_axe_digits;
   color axe_label_color;
   int axe_label_size;   
   //     
   struct Line
   {  
      // 
      int ID;
      //   
      CArrayDouble X_data;
      CArrayDouble Y_data;
      CArrayDouble Z_data;
      CArrayDouble H_data;
      //  
      int data_amount; 
      //
      color color_; 
      //   
      int digits;  
      //
      string legend;
      //
      int thickness;
      int dash_length;
      int space_length;
      //
      int marker_type;
      color marker_color;
      int marker_size;
      double marker_z_order;
      //
      int fill_type;
      color fill_color;
      int fill_start;
      int fill_end;
      //     
      double x_min, y_min, x_max, y_max;
      // 
      bool scaling;
      double stretch;
      //  CPieChart
      int dimensional;
      //
      void Line(){ID=-1;}
   };
   ///C     
   struct Label
   {
      // 
      int ID;
      // ,   
      int line_ID;
      //
      int type;
      // 
      int data_point;
      //
      string text;
      //
      color color_;
      //
      int size;
      // 
      double z_order;
      // 
      int h_placement;
      // 
      int v_placement;
      //
      void Label() {ID=-1; line_ID=-1;}
   };
   Line Lines[100];
   Label Labels[100];
   void GetLinesMaxMin();
   void GetChartMaxMin();
   void ReqGrid(CString &res);
   void ReqAxisLabels(CString &res);
   void ReqSize(CString &res);
   void ReqTitle(CString &res);
   void ReqFill(CString &res);
   void ReqMargins(CString &res);
   void ReqLineData(CString &res);
   void ReqLineColor(CString &res);
   void ReqLineStyle(CString &res);
   void ReqLineLegend(CString &res);
   void ReqLineScaling(CString &res);
   void ReqLineMarkers(CString &res);
   void ReqLineFilling(CString &res);   
   void ReqLineLabels(CString &res);
public:
   int AddLine(double &Y_data[], double &X_data[], color color_, int digits, string legend);
   int AddLine(double &Data[], color color_, int digits, string legend);
   int AddLine(CArrayDouble *Y_data, CArrayDouble *X_data, color color_, int digits, string legend);
   int AddLine(CArrayDouble *Data, color color_, int digits, string legend);   
   bool SetLineData(int line_ID, double &Y_data[], double &X_data[]);
   bool SetLineData(int line_ID, double &Data[]);
   bool SetLineData(int line_ID, CArrayDouble *Y_data, CArrayDouble *X_data);
   bool SetLineData(int line_ID, CArrayDouble *Data);
   void DeleteLine(int line_ID);
   bool SetLineStyle(int line_ID, int thickness, int dash_length, int space_length);
   bool SetLineMarker(int line_ID, DIAGRAM_LINE_MARKERS marker_type, color marker_color, int marker_size, double marker_z_order);
   bool SetLineFilling(int line_ID, color fill_color, int fill_line_ID);
   bool SetLineFilling(int line_ID, color fill_color, int start_index, int end_index);
   bool SetLineScaling(int line_ID, bool scaling, double stretch);
   int AddLabel(int line_ID, DIAGRAM_LABELS_TYPE type, int data_point, string text, color color_, int size); 
   bool SetLabelPlacement(int label_ID, double z_order, 
      DIAGRAM_LABELS_HORIZONTAL_PLACEMENT h_placement, DIAGRAM_LABELS_VERTICAL_PLACEMENT v_placement);
   void DeleteLabel(int label_ID);
   int GetLineID(int pos);
   int GetLinePos(int line_ID);
   int GetLabelID(int pos);
   int GetLabelPos(int line_ID);   
   //+------------------------------------------------------------------+
   //    
   // :    
   //+------------------------------------------------------------------+
   int LinesTotal() {return total_lines;}
   //+------------------------------------------------------------------+
   //    
   // :    
   //+------------------------------------------------------------------+   
   int LabelsTotal() {return total_labels;}
   void SetAxis(int Axis, int line_ID, double step, color color_, int size, int digits);
   //+------------------------------------------------------------------+
   // 
   // x_step -   -
   // y_step -   Y-
   //: x_step  y_step      0..100,    ..     -   100/x_step,  Y- 100/y_step
   //+------------------------------------------------------------------+   
   void SetGrid(double x_step=20, double y_step=20) {grid=true; grid_x=x_step; grid_y=y_step;}
   void HideGrid() {grid=false;}
   void SetAxisLabels(string bottom, string top, string left, string right, color color_, int size);
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_LINEXY;}
   void CLineXYChart();   
};
//+------------------------------------------------------------------+
///
void CLineXYChart::CLineXYChart()
{
   total_lines=0;
   total_labels=0;
   axes=0;
   xmax_val=DBL_MIN; xmin_val=DBL_MAX;
   ymax_val=DBL_MIN; ymin_val=DBL_MAX;
   bottom_axe_line=top_axe_line=left_axe_line=right_axe_line=-2;
   grid=false;
   bottom_axe_label=top_axe_label=left_axe_label=right_axe_label="";
   bottom_axe_index=top_axe_index=left_axe_index=right_axe_index=-1;
}
//+------------------------------------------------------------------+
//    
// bottom - X-
// top -  
// left - Y-
// right -  
// color_ - 
// size - 
//+------------------------------------------------------------------+
void CLineXYChart::SetAxisLabels(string bottom="", string top="", string left="", string right="", color color_=Black, int size=14)
{
   bottom_axe_label=Remove_spaces(bottom); 
   top_axe_label=Remove_spaces(top); 
   left_axe_label=Remove_spaces(left); 
   right_axe_label=Remove_spaces(right);
   axe_label_color=color_;
   axe_label_size=size;
}
//+------------------------------------------------------------------+
//  
// line_ID - 
// scaling -false-     , true-  
// stretch -      (0-   )
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+ 
bool CLineXYChart::SetLineScaling(int line_ID, bool scaling, double stretch=0)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].scaling=scaling;
         Lines[i].stretch=stretch;
         return true;
      }
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);    
   return false;   
}
//+------------------------------------------------------------------+
//  
// Axis -   DIAGRAM_AXIS
// line_ID - 
// step - 
// color_ - 
// size - 
// digits -   
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
void CLineXYChart::SetAxis(int Axis, int line_ID=-1, double step=0, color color_=Black, int size=10, int digits=2)
{
   int tmp_axe=Axis;
   if(tmp_axe & DIAGRAM_AXIS_BOTTOM) 
   {
      bottom_axe_line=line_ID; 
      bottom_axe_step=step; 
      bottom_axe_digits=digits; 
      bottom_axe_color=color_;
      bottom_axe_size=size;
   } 
   tmp_axe=Axis;
   if(tmp_axe & DIAGRAM_AXIS_TOP) 
   {
      top_axe_line=line_ID; 
      top_axe_step=step; 
      top_axe_digits=digits; 
      top_axe_color=color_;
      top_axe_size=size;
   } 
   tmp_axe=Axis;
   if(tmp_axe & DIAGRAM_AXIS_LEFT) 
   {
      left_axe_line=line_ID; 
      left_axe_step=step; 
      left_axe_digits=digits; 
      left_axe_color=color_;
      left_axe_size=size;
   } 

   tmp_axe=Axis;
   if(tmp_axe & DIAGRAM_AXIS_RIGHT)
   {
      right_axe_line=line_ID; 
      right_axe_step=step; 
      right_axe_digits=digits; 
      right_axe_color=color_;
      right_axe_size=size;
   } 
}
//+------------------------------------------------------------------+
void CLineXYChart::GetChartMaxMin()
{
   GetLinesMaxMin();
   xmax_val=DBL_MIN; xmin_val=DBL_MAX;
   ymax_val=DBL_MIN; ymin_val=DBL_MAX;
   for(int i=0;i<100;i++)
      if(Lines[i].ID>-1 && !Lines[i].scaling) 
      {
         if(Lines[i].x_max>xmax_val) xmax_val=Lines[i].x_max;
         if(Lines[i].x_min<xmin_val) xmin_val=Lines[i].x_min;
         if(Lines[i].y_max>ymax_val) ymax_val=Lines[i].y_max;
         if(Lines[i].y_min<ymin_val) ymin_val=Lines[i].y_min;
      }   
}
//+------------------------------------------------------------------+
void CLineXYChart::GetLinesMaxMin()
{
   for(int i=0;i<100;i++)
      if(Lines[i].ID>-1) 
      {
         Lines[i].x_max=DBL_MIN; Lines[i].x_min=DBL_MAX;
         Lines[i].y_max=DBL_MIN; Lines[i].y_min=DBL_MAX;
         for(int j=0;j<Lines[i].X_data.Total();j++)
         {
            if(Lines[i].X_data.At(j)>Lines[i].x_max) Lines[i].x_max=Lines[i].X_data.At(j);
            if(Lines[i].X_data.At(j)<Lines[i].x_min) Lines[i].x_min=Lines[i].X_data.At(j);
         }
         for(int j=0;j<Lines[i].Y_data.Total();j++)
         {
            if(Lines[i].Y_data.At(j)>Lines[i].y_max) Lines[i].y_max=Lines[i].Y_data.At(j);
            if(Lines[i].Y_data.At(j)<Lines[i].y_min) Lines[i].y_min=Lines[i].Y_data.At(j);
         }     
         Lines[i].y_max=Lines[i].y_max+(Lines[i].y_max-Lines[i].y_min)*Lines[i].stretch/100.0;    
         Lines[i].y_min=Lines[i].y_min-(Lines[i].y_max-Lines[i].y_min)*Lines[i].stretch/100.0; 
      }   
}
//+------------------------------------------------------------------+
//       
// pos -   
//:      ,    GetLastError()
// :     ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::GetLineID(int pos)
{
   int cnt=0;
   for(int i=0;i<100;i++)
      if(Lines[i].ID>-1) 
      {
         if(cnt==pos) return Lines[i].ID;
         cnt++;
      }   
   return -1;   
}
//+------------------------------------------------------------------+
//       
// line_ID -  
//:      ,    GetLastError()
// :     ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::GetLinePos(int line_ID)
{
   int cnt=0;
   for(int i=0;i<100;i++)
      if(Lines[i].ID>-1) 
      {
         if(Lines[i].ID==line_ID) return cnt;
         cnt++;
      }   
   return -1;   
}
//+------------------------------------------------------------------+
//       
// pos -   
//:      ,    GetLastError()
// :     ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::GetLabelID(int pos)
{
   int cnt=0;
   for(int i=0;i<100;i++)
      if(Labels[i].ID>-1) 
      {
         if(cnt==pos) return Labels[i].ID;
         cnt++;
      }   
   return -1;   
}
//+------------------------------------------------------------------+
//       
// label_ID -  
//:      ,    GetLastError()
// :     ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::GetLabelPos(int label_ID)
{
   int cnt=0;
   for(int i=0;i<100;i++)
      if(Labels[i].ID>-1) 
      {
         if(Labels[i].ID==label_ID) return cnt;
         cnt++;
      }   
   return -1;   
}
//+------------------------------------------------------------------+
// 
// line_ID - ,     
// type - 
// data_point -   
// text - 
// color_ -
// size -
//:      ,    GetLastError()
// :       ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::AddLabel(int line_ID, DIAGRAM_LABELS_TYPE type, int data_point, string text, color color_, int size)
   
{
   for(int i=0;i<100;i++) 
      if(Labels[i].ID==-1) 
      {
         Labels[i].line_ID=line_ID;
         Labels[i].type=type;
         Labels[i].data_point=data_point;
         Labels[i].text=text;
         Labels[i].color_=color_;
         Labels[i].size=size;
         Labels[i].z_order=0;
         Labels[i].h_placement=1;
         Labels[i].v_placement=1;
         Labels[i].ID=total_labels++;
         return Labels[i].ID;
      }
   SetUserError(DIAGRAM_ERR_TOO_MANY_LABELS);   
   return -1;
}
//+------------------------------------------------------------------+
//     
// label_ID - 
// z_order -  
// h_placement -  
// v_placement -  
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLabelPlacement(int label_ID, double z_order, 
   DIAGRAM_LABELS_HORIZONTAL_PLACEMENT h_placement, DIAGRAM_LABELS_VERTICAL_PLACEMENT v_placement)
{
   for(int i=0;i<100;i++) 
      if(Labels[i].ID==label_ID) 
      {
         Labels[i].z_order=0;
         Labels[i].h_placement=1;
         Labels[i].v_placement=1;
         Labels[i].ID=total_labels++;
         return true;
      }
   SetUserError(DIAGRAM_ERR_INCORRECT_LABEL_ID);   
   return false;
}
//+------------------------------------------------------------------+
//  
// line_ID - 
// thickness -
// dash_length - 
// space_length - 
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineStyle(int line_ID, int thickness, int dash_length, int space_length)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].thickness=thickness;
         Lines[i].dash_length=dash_length;
         Lines[i].space_length=space_length;
         return true;
      }
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);    
   return false;   
}
//+------------------------------------------------------------------+
//    
// line_ID - 
// Y_data -  Y 
// X_data -   
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineData(int line_ID, double &Y_data[], double &X_data[])
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].Y_data.AssignArray(Y_data);
         Lines[i].X_data.AssignArray(X_data);
         return true;
      }  
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);     
   return false;    

}
//+------------------------------------------------------------------+
//    
// line_ID - 
// Data -  Y 
//:      ,    GetLastError()
//:        -      0...N
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineData(int line_ID, double &Data[])
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].Y_data.AssignArray(Data);
         double X_Data[];
         int y_size=ArrayRange(Data, 0);
         ArrayResize(X_Data, y_size); 
         for(int j=0;j<y_size;j++) X_Data[j]=j;
         Lines[i].X_data.AssignArray(X_Data);
         return true;
      }  
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);     
   return false;    

}
//+------------------------------------------------------------------+
//    
// line_ID - 
// Y_data -  Y 
// X_data -   
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineData(int line_ID, CArrayDouble *Y_data, CArrayDouble *X_data)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].Y_data.AssignArray(Y_data);
         Lines[i].X_data.AssignArray(X_data);
         return true;
      }  
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);     
   return false;    

}
//+------------------------------------------------------------------+
//    
// line_ID - 
// Data -  Y 
//:      ,    GetLastError()
//:        -      0...N
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineData(int line_ID, CArrayDouble *Data)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].Y_data.AssignArray(Data);
         double X_Data[];
         int y_size=Data.Total();
         ArrayResize(X_Data, y_size); 
         for(int j=0;j<y_size;j++) X_Data[j]=j;
         Lines[i].X_data.AssignArray(X_Data);       
         return true;
      }  
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);     
   return false;    

}
//+------------------------------------------------------------------+
//  
// line_ID - 
// marker_type - 
// marker_color -
// marker_size -  
// marker_z_order -  
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineMarker(int line_ID, DIAGRAM_LINE_MARKERS marker_type, color marker_color, int marker_size, double marker_z_order=0)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].marker_type=marker_type;
         Lines[i].marker_color=marker_color;
         Lines[i].marker_size=marker_size;
         Lines[i].marker_z_order=marker_z_order;
         return true;
      }  
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);     
   return false;    
}
//+------------------------------------------------------------------+
//     
// line_ID - 
// fill_color - 
// fill_line_ID -  
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineFilling(int line_ID, color fill_color, int fill_line_ID)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         if(GetLinePos(fill_line_ID)<0) 
            {SetUserError(DIAGRAM_ERR_INCORRECT_FILL_INDEX); return false;}
         Lines[i].fill_type=1;
         Lines[i].fill_color=fill_color;
         Lines[i].fill_start=fill_line_ID;
         Lines[i].fill_end=0;
         return true;
      }   
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);    
   return false;    
}
//+------------------------------------------------------------------+
//    
// line_ID - 
// fill_color - 
// start_index -      
// end_index -      
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CLineXYChart::SetLineFilling(int line_ID, color fill_color, int start_index, int end_index)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return false;}
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==line_ID) 
      {
         Lines[i].fill_type=2;
         Lines[i].fill_color=fill_color;
         Lines[i].fill_start=start_index;
         Lines[i].fill_end=end_index;
         return true;
      }   
   SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);    
   return false;    
}
//+------------------------------------------------------------------+
// 
// Data -  Y 
// color_ - 
// digits -    
// legend -
//:      ,    GetLastError()
//:        -      0...N
// :    ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::AddLine(double &Data[], color color_=Red, int digits=8, string legend="")
{
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==-1) 
      {
         int y_size=ArrayRange(Data, 0);
         double X_Data[];
         ArrayResize(X_Data, y_size); 
         for(int j=0;j<y_size;j++) X_Data[j]=j;
         Lines[i].X_data.AssignArray(X_Data);
         Lines[i].Y_data.AssignArray(Data);
         Lines[i].data_amount=y_size;
         Lines[i].color_=color_;
         Lines[i].digits=digits;
         Lines[i].legend=Remove_spaces(legend, "+");
         //style
         Lines[i].thickness=1;
         Lines[i].dash_length=1;
         Lines[i].space_length=0;   
         //marker
         Lines[i].marker_type=0;  
         Lines[i].marker_size=0;  
         Lines[i].marker_color=0; 
         Lines[i].marker_z_order=0; 
         //filling
         Lines[i].fill_type=0;
         Lines[i].fill_color=0;
         Lines[i].fill_start=0;
         Lines[i].fill_end=0;
         //scaling
         Lines[i].scaling=false;
         Lines[i].stretch=0;
         //id    
         Lines[i].dimensional=0;
         Lines[i].ID=total_lines++;
         return Lines[i].ID;
      }
   SetUserError(DIAGRAM_ERR_TOO_MANY_LINES);   
   return -1;   
}
//+------------------------------------------------------------------+
// 
// Y_Data -  Y 
// X_Data -   
// color_ - 
// digits -    
// legend -
//:      ,    GetLastError()
// :    ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::AddLine(double &Y_Data[], double &X_Data[], color color_=Red, int digits=8, string legend="")
{
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==-1) 
      {
         int y_size=ArrayRange(Y_Data, 0);
         int x_size=ArrayRange(X_Data, 0);
         if(y_size!=x_size) 
            return(AddLine(Y_Data, color_, digits, legend));
         Lines[i].X_data.AssignArray(X_Data);
         Lines[i].Y_data.AssignArray(Y_Data);
         Lines[i].data_amount=y_size;
         Lines[i].color_=color_;
         Lines[i].digits=digits;
         Lines[i].legend=Remove_spaces(legend, "+");
         //style
         Lines[i].thickness=1;
         Lines[i].dash_length=1;
         Lines[i].space_length=0;   
         //marker
         Lines[i].marker_type=0;  
         Lines[i].marker_size=0;  
         Lines[i].marker_color=0; 
         Lines[i].marker_z_order=0; 
         //filling
         Lines[i].fill_type=0;
         Lines[i].fill_color=0;
         Lines[i].fill_start=0;
         Lines[i].fill_end=0;     
         //id    
         Lines[i].dimensional=0;
         Lines[i].ID=total_lines++;
         return Lines[i].ID;
      }
   SetUserError(DIAGRAM_ERR_TOO_MANY_LINES);   
   return -1;
}
//+------------------------------------------------------------------+
// 
// Data -  Y 
// color_ - 
// digits -    
// legend -
//:      ,    GetLastError()
//:        -      0...N
// :    ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::AddLine(CArrayDouble *Data, color color_=Red, int digits=8, string legend="")
{
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==-1) 
      {
         int y_size=Data.Total();
         double X_Data[];
         ArrayResize(X_Data, y_size); 
         for(int j=0;j<y_size;j++) X_Data[j]=j;
         Lines[i].X_data.AssignArray(X_Data);
         Lines[i].Y_data.AssignArray(Data);
         Lines[i].data_amount=y_size;
         Lines[i].color_=color_;
         Lines[i].digits=digits;
         Lines[i].legend=Remove_spaces(legend, "+");
         //style
         Lines[i].thickness=1;
         Lines[i].dash_length=1;
         Lines[i].space_length=0;   
         //marker
         Lines[i].marker_type=0;  
         Lines[i].marker_size=0;  
         Lines[i].marker_color=-1; 
         Lines[i].marker_z_order=0; 
         //filling
         Lines[i].fill_type=0;
         Lines[i].fill_color=0;
         Lines[i].fill_start=0;
         Lines[i].fill_end=0; 
         //id    
         Lines[i].dimensional=0;
         Lines[i].ID=total_lines++;
         return Lines[i].ID;
      }
   SetUserError(DIAGRAM_ERR_TOO_MANY_LINES);   
   return -1;   
}
//+------------------------------------------------------------------+
// 
// Y_Data -  Y 
// X_Data -   
// color_ - 
// digits -    
// legend -
//:      ,    GetLastError()
// :    ,  -1
//+------------------------------------------------------------------+
int CLineXYChart::AddLine(CArrayDouble *Y_Data, CArrayDouble *X_Data, color color_=Red, int digits=8, string legend="")
{
   for(int i=0;i<100;i++) 
      if(Lines[i].ID==-1) 
      {
         int y_size=Y_Data.Total();
         int x_size=X_Data.Total();
         if(y_size!=x_size) 
            return(AddLine(Y_Data, color_, digits, legend));
         Lines[i].X_data.AssignArray(X_Data);
         Lines[i].Y_data.AssignArray(Y_Data);
         Lines[i].data_amount=y_size;
         Lines[i].color_=color_;
         Lines[i].digits=digits;
         Lines[i].legend=Remove_spaces(legend, "+");
         //style
         Lines[i].thickness=1;
         Lines[i].dash_length=1;
         Lines[i].space_length=0;   
         //marker
         Lines[i].marker_type=0;  
         Lines[i].marker_size=0;  
         Lines[i].marker_color=0; 
         Lines[i].marker_z_order=0; 
         //filling
         Lines[i].fill_type=0;
         Lines[i].fill_color=-1;
         Lines[i].fill_start=0;
         Lines[i].fill_end=0;      
         //id    
         Lines[i].dimensional=0;
         Lines[i].ID=total_lines++;
         return Lines[i].ID;
      }
   SetUserError(DIAGRAM_ERR_TOO_MANY_LINES);   
   return -1;
}
//+------------------------------------------------------------------+
//   
// line_ID - 
//+------------------------------------------------------------------+
void CLineXYChart::DeleteLine(int line_ID)
{
   if(line_ID<0 || line_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID); return;}
   if(Lines[line_ID].ID>-1) 
   {
      Lines[line_ID].X_data.Shutdown();
      Lines[line_ID].Y_data.Shutdown();
      Lines[line_ID].Z_data.Shutdown();
      Lines[line_ID].ID=-1; 
      total_lines--;
   }
   else SetUserError(DIAGRAM_ERR_INCORRECT_LINE_ID);
}
//+------------------------------------------------------------------+
//   
// label_ID - 
//+------------------------------------------------------------------+
void CLineXYChart::DeleteLabel(int label_ID)
{
   if(label_ID<0 || label_ID>99) {SetUserError(DIAGRAM_ERR_INCORRECT_LABEL_ID); return;}
   if(Labels[label_ID].ID>-1) 
   {
      Labels[label_ID].ID=-1; 
      total_labels--;
   }
   else SetUserError(DIAGRAM_ERR_INCORRECT_LABEL_ID);
}
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CLineXYChart::CreateRequest()
{
   GetChartMaxMin();
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=lxy");
   ReqSize(res);
   ReqGrid(res);
   ReqAxisLabels(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqLineData(res);
   ReqLineColor(res);
   ReqLineStyle(res);
   ReqLineMarkers(res);
   ReqLineFilling(res);
   ReqLineLabels(res);
   ReqLineLegend(res);
   ReqLineScaling(res);
   return res.Str();
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineLabels(CString &res)
{
   if(total_lines>0)
   {
      CString labels_str;
      for(int i=0;i<100;i++)
         if(Labels[i].ID>-1)
         {
            bool fail=false;
            switch (Labels[i].type)
            {
               case 1: {labels_str.Append("f"+Labels[i].text+","); break;}
               case 2: {labels_str.Append("t"+Labels[i].text+","); break;}
               case 3: {labels_str.Append("A"+Labels[i].text+","); break;}
               default: {SetUserError(DIAGRAM_ERR_INVALID_LABEL_TYPE); fail=true;}
            }
            if(!fail)
            {
               labels_str.Append(GetColorStr(Labels[i].color_)+",");
               labels_str.Append(IntegerToString(GetLinePos(Labels[i].line_ID))+",");
               labels_str.Append(IntegerToString(Labels[i].data_point)+",");
               labels_str.Append(IntegerToString(Labels[i].size)+",");
               labels_str.Append(DoubleToString(Labels[i].z_order, 2)+",");
               switch(Labels[i].h_placement)
               {
                  case 1: {labels_str.Append("l"); break;}
                  case 2: {labels_str.Append("h"); break;}
                  case 3: {labels_str.Append("r"); break;}
                  default: labels_str.Append("l");
               }
               switch(Labels[i].v_placement)
               {
                  case 1: {labels_str.Append("b|"); break;}
                  case 2: {labels_str.Append("v|"); break;}
                  case 3: {labels_str.Append("t|"); break;}
                  default: labels_str.Append("b|");
               }               
            }
         }
      //---     
      if(labels_str.Str()!="")
      {
         labels_str.TrimRight("|");
         int pos=res.Find(0, "&chm=");
         if(pos>-1) 
         {
            res.Insert(pos+5, labels_str.Str()+"|");
         }
         else 
         {
            res.Append("&chm=");
            res.Append(GetPointer(labels_str));
         }
      }  
   }              
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineStyle(CString &res)
{
   if(total_lines>0)
   {
      CString style_str;
      for(int i=0;i<100;i++) 
         if(Lines[i].ID>-1)
         {
            style_str.Append(IntegerToString(Lines[i].thickness)+",");
            style_str.Append(IntegerToString(Lines[i].dash_length)+",");
            style_str.Append(IntegerToString(Lines[i].space_length)+"|");
         }   
      res.Append("&chls=");
      style_str.TrimRight("|");
      res.Append(GetPointer(style_str));
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineScaling(CString &res)
{
   if(total_lines>0)
   {
      CString scale_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
         {
            if(!Lines[i].scaling)
            {
               scale_str.Append(DoubleToString(xmin_val)+","+DoubleToString(xmax_val)+",");
               scale_str.Append(DoubleToString(ymin_val)+","+DoubleToString(ymax_val)+",");
            }
            else
            {
               scale_str.Append(DoubleToString(Lines[i].x_min)+","+DoubleToString(Lines[i].x_max)+",");
               scale_str.Append(DoubleToString(Lines[i].y_min)+","+DoubleToString(Lines[i].y_max)+",");
            }
         }   
      res.Append("&chds=");
      scale_str.TrimRight(",");
      res.Append(GetPointer(scale_str));
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineLegend(CString &res)
{
   if(total_lines>0)
   {
      CString legend_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
            legend_str.Append(Lines[i].legend+"|");
      if(legend_position>0)
      {
         res.Append("&chdl=");
         legend_str.TrimRight("|");
         res.Append(GetPointer(legend_str));
         res.Append("&chdlp=");
         switch (legend_position)
         {
            case 1: {res.Append("r"); break;}
            case 2: {res.Append("b"); break;}
            case 3: {res.Append("bv"); break;}
            case 4: {res.Append("t"); break;}
            case 5: {res.Append("tv"); break;}
            case 6: {res.Append("l"); break;}
            default: res.Append("r"); 
         }
      }  
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineFilling(CString &res)
{
   if(total_lines>0)
   {
      CString marker_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
         {
            //---
            if(Lines[i].fill_type>0)
            {
               bool fail=false;
               switch(Lines[i].fill_type)
               {
                  case 1: {marker_str.Append("b,"); break;}
                  case 2: {marker_str.Append("B,"); break;}
                  default : {SetUserError(DIAGRAM_ERR_INVALID_FILLING_TYPE); fail=true;} 
               }
               if(!fail)
               {
                  marker_str.Append(GetColorStr(Lines[i].fill_color)+",");
                  switch(Lines[i].fill_type)
                  {
                     case 1: 
                     {
                        marker_str.Append(IntegerToString(GetLinePos(Lines[i].fill_start))+",");
                        marker_str.Append(IntegerToString(GetLinePos(Lines[i].ID))+",0|");
                        break;
                     }
                     case 2: 
                     {
                        marker_str.Append(IntegerToString(GetLinePos(Lines[i].ID))+",");
                        marker_str.Append(IntegerToString(Lines[i].fill_start)+":");
                        marker_str.Append(IntegerToString(Lines[i].fill_end)+",0|");
                        break;
                     }
                  }
               }
            }  
            //---         
         }   
      //---
      if(marker_str.Str()!="")
      { 
         marker_str.TrimRight("|");
         int pos=res.Find(0, "&chm=");
         if(pos>-1) 
         {
            res.Insert(pos+5, marker_str.Str()+"|");
         }
         else 
         {
            res.Append("&chm=");
            res.Append(GetPointer(marker_str));
         }
      }
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineMarkers(CString &res)
{
   if(total_lines>0)
   {
      CString marker_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
         {
            //---
            if(Lines[i].marker_type>0)
            {
               bool fail=false;
               switch(Lines[i].marker_type)
               {
                  case 1: {marker_str.Append("a,"); break;}
                  case 2: {marker_str.Append("c,"); break;}
                  case 3: {marker_str.Append("d,"); break;}
                  case 4: {marker_str.Append("o,"); break;}
                  case 5: {marker_str.Append("s,"); break;}
                  default : {SetUserError(DIAGRAM_ERR_INVALID_MARKER_TYPE); fail=true;} 
               }
               if(!fail)
               {
                  marker_str.Append(GetColorStr(Lines[i].marker_color)+",");
                  marker_str.Append(IntegerToString(GetLinePos(Lines[i].ID))+",-1,");
                  marker_str.Append(IntegerToString(Lines[i].marker_size)+",");
                  marker_str.Append(DoubleToString(Lines[i].marker_z_order, 2)+"|");
               }
            }
            //---       
         }   
      //---
      if(marker_str.Str()!="")
      { 
         marker_str.TrimRight("|");
         int pos=res.Find(0, "&chm=");
         if(pos>-1) 
         {
            res.Insert(pos+5, marker_str.Str()+"|");
         }
         else 
         {
            res.Append("&chm=");
            res.Append(GetPointer(marker_str));
         }
      }
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineColor(CString &res)
{
   if(total_lines>0)
   {
      CString color_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
            color_str.Append(GetColorStr(Lines[i].color_)+","); 
      res.Append("&chco=");
      color_str.TrimRight(",");
      res.Append(GetPointer(color_str));
   }      
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqLineData(CString &res)
{
   if(total_lines>0)
   {
      CString data_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
         {
            CString xdata_str, ydata_str;
            for(int j=0;j<Lines[i].data_amount;j++)
            {
               xdata_str.Append(DoubleToString(Lines[i].X_data.At(j), Lines[i].digits)+",");
               ydata_str.Append(DoubleToString(Lines[i].Y_data.At(j), Lines[i].digits)+",");
            }  
            xdata_str.TrimRight(",");
            ydata_str.TrimRight(",");  
            data_str.Append(GetPointer(xdata_str)); 
            data_str.Append("|"); 
            data_str.Append(GetPointer(ydata_str));
            data_str.Append("|");  
         } 
      res.Append("&chd=t:");
      data_str.TrimRight("|");
      res.Append(GetPointer(data_str));       
    }     
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqMargins(CString &res)
{
   if(margin_bottom+margin_left+margin_right+margin_top+legend_height_+legend_width_ > 0)
   {
      res.Append("&chma=");
      res.Append(IntegerToString(margin_left)+",");
      res.Append(IntegerToString(margin_right)+",");
      res.Append(IntegerToString(margin_top)+",");
      res.Append(IntegerToString(margin_bottom)+"|");
      if(legend_height_+legend_width_ > 0)
      {
         res.Append(IntegerToString(legend_height_)+",");
         res.Append(IntegerToString(legend_width_));
      }
      else res.TrimRight("|");
   } 
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqFill(CString &res)
{
   if(fill_chart>-1)
      res.Append("&chf=c,s,"+GetColorStr(fill_chart)+"|bg,s,"+GetColorStr(fill_bg));
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqTitle(CString &res)
{
   if(title!="")
      res.Append("&chtt="+title+"&chts="+GetColorStr(title_color)+","+IntegerToString(title_font_size));   
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqSize(CString &res)
{
   res.Append("&chs=");
   res.Append(IntegerToString(X));
   res.Append("x");
   res.Append(IntegerToString(Y));   
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqGrid(CString &res)
{
   if(grid)
   {
      res.Append("&chg=");
      res.Append(DoubleToString(grid_x)+","+DoubleToString(grid_y));
   }
}
//+------------------------------------------------------------------+
void CLineXYChart::ReqAxisLabels(CString &res)
{
   CString axis_range, axis_types, styles;
   int axe_cnt=0;
   if(bottom_axe_line>-2)
   {
      bottom_axe_index=axe_cnt;
      styles.Append(IntegerToString(bottom_axe_index));
      styles.Append("N*f"+IntegerToString(bottom_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(bottom_axe_color)+",");
      styles.Append(IntegerToString(bottom_axe_size)+",");
      styles.Append("0,lt|");
      //**************************
      axis_types.Append("x,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(bottom_axe_label!="") {axis_types.Append("x,"); axe_cnt++;}
      if(bottom_axe_line==-1)
      {
         axis_range.Append(DoubleToString(xmin_val)+",");
         axis_range.Append(DoubleToString(xmax_val));
      }
      else 
      {
         axis_range.Append(DoubleToString(Lines[GetLinePos(bottom_axe_line)].x_min)+",");
         axis_range.Append(DoubleToString(Lines[GetLinePos(bottom_axe_line)].x_max));
      }
      if(bottom_axe_step!=0) 
         axis_range.Append(","+DoubleToString(bottom_axe_step)+"|");
      else axis_range.Append("|");   
   }
   //---
   if(top_axe_line>-2)
   {
      top_axe_index=axe_cnt;
      styles.Append(IntegerToString(top_axe_index));
      styles.Append("N*f"+IntegerToString(top_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(top_axe_color)+",");
      styles.Append(IntegerToString(top_axe_size)+",");
      styles.Append("0,lt|");
      //**************************      
      axis_types.Append("t,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(top_axe_label!="") {axis_types.Append("t,"); axe_cnt++;}
      if(top_axe_line==-1)
      {
         axis_range.Append(DoubleToString(xmin_val)+",");
         axis_range.Append(DoubleToString(xmax_val));
      }
      else
      {
         axis_range.Append(DoubleToString(Lines[GetLinePos(top_axe_line)].x_min)+",");
         axis_range.Append(DoubleToString(Lines[GetLinePos(top_axe_line)].x_max));
      }
      if(top_axe_step!=0) 
         axis_range.Append(","+DoubleToString(top_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   if(left_axe_line>-2)
   {
      left_axe_index=axe_cnt;
      styles.Append(IntegerToString(left_axe_index));
      styles.Append("N*f"+IntegerToString(left_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(left_axe_color)+",");
      styles.Append(IntegerToString(left_axe_size)+",");
      styles.Append("0,lt|");
      //**************************         
      axis_types.Append("y,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(left_axe_label!="") {axis_types.Append("y,"); axe_cnt++;}
      if(left_axe_line==-1)
      {
         axis_range.Append(DoubleToString(ymin_val)+",");
         axis_range.Append(DoubleToString(ymax_val));
      }
      else
      {
         axis_range.Append(DoubleToString(Lines[GetLinePos(left_axe_line)].y_min)+",");
         axis_range.Append(DoubleToString(Lines[GetLinePos(left_axe_line)].y_max));
      }
      if(left_axe_step!=0) 
         axis_range.Append(","+DoubleToString(left_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   if(right_axe_line>-2)
   {
      right_axe_index=axe_cnt;
      styles.Append(IntegerToString(right_axe_index));
      styles.Append("N*f"+IntegerToString(right_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(right_axe_color)+",");
      styles.Append(IntegerToString(right_axe_size)+",");
      styles.Append("0,lt|");
      //**************************         
      axis_types.Append("r,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(right_axe_label!="") {axis_types.Append("r,"); axe_cnt++;}
      if(right_axe_line==-1)
      {
         axis_range.Append(DoubleToString(ymin_val)+",");
         axis_range.Append(DoubleToString(ymax_val));
      }
      else
      {
         axis_range.Append(DoubleToString(Lines[GetLinePos(right_axe_line)].y_min)+",");
         axis_range.Append(DoubleToString(Lines[GetLinePos(right_axe_line)].y_max));
      }
      if(right_axe_step!=0) 
         axis_range.Append(","+DoubleToString(right_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   res.Append("&chxt=");
   axis_types.TrimRight(",");
   res.Append(GetPointer(axis_types));
   res.Append("&chxr=");
   axis_range.TrimRight("|");
   res.Append(GetPointer(axis_range));
   //---
   CString labels, positions;
   if(bottom_axe_index>-1 && bottom_axe_label!="")
   {
      styles.Append(IntegerToString(bottom_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");
      labels.Append(IntegerToString(bottom_axe_index+1)+":|"+bottom_axe_label+"|");
      positions.Append(IntegerToString(bottom_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(top_axe_index>-1 && top_axe_label!="")
   {
      styles.Append(IntegerToString(top_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");   
      labels.Append(IntegerToString(top_axe_index+1)+":|"+top_axe_label+"|");
      positions.Append(IntegerToString(top_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(left_axe_index>-1 && left_axe_label!="")
   {
      styles.Append(IntegerToString(left_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");
      labels.Append(IntegerToString(left_axe_index+1)+":|"+left_axe_label+"|");
      positions.Append(IntegerToString(left_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(right_axe_index>-1 && right_axe_label!="")
   {
      styles.Append(IntegerToString(right_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");   
      labels.Append(IntegerToString(right_axe_index+1)+":|"+right_axe_label+"|");
      positions.Append(IntegerToString(right_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   //---
   labels.TrimRight("|");
   positions.TrimRight("|");
   styles.TrimRight("|");
   res.Append("&chxl=");
   res.Append(GetPointer(labels));
   res.Append("&chxp=");
   res.Append(GetPointer(positions));   
   res.Append("&chxs=");
   res.Append(GetPointer(styles));   
}
//+------------------------------------------------------------------+
//\class CFormulaChart
//\brief    
//:   CLineXYChart
//+------------------------------------------------------------------+
class CFormulaChart : public CLineXYChart
{
protected:
   string data;
   color formula_color;
   void ReqFormulaColor(CString &res);
public:
   //+------------------------------------------------------------------+
   //   
   // formula -   
   //:      <a href="http://en.wikipedia.org/wiki/TeX">TeX</a>
   //+------------------------------------------------------------------+
   void SetFormulaString(string formula) {data=formula;}
   //+------------------------------------------------------------------+
   //  
   // Color - 
   //+------------------------------------------------------------------+   
   void SetFormulaColor(color Color) {formula_color=Color;}
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_FORMULA;}
   void CFormulaChart();
};
//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
void CFormulaChart::CFormulaChart()
{
   formula_color=Black;
   data="";
}
//+------------------------------------------------------------------+
void CFormulaChart::ReqFormulaColor(CString &res)
{
   res.Append("&chco="+GetColorStr(formula_color));
}
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CFormulaChart::CreateRequest()
{
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=tx&chl="+data);
   ReqSize(res);
   ReqFill(res);
   ReqTitle(res);
   ReqFormulaColor(res);
   return res.Str();
}
//+------------------------------------------------------------------+
//\class CGraphChart
//\brief    
//:   CLineXYChart
//+------------------------------------------------------------------+
class CGraphChart : public CLineXYChart
{
protected:
   string nodes[200];
   int edges[400][2];
   int nodes_total;
   int edges_total;
   bool graph_type;
   int engine;
   void ReqData(CString &res);
public:
   int AddNode(string text);
   int AddEdge(int Node_A, int Node_B);
   bool DeleteNode(int node_ID);
   bool DeleteEdge(int edge_ID);
   //+------------------------------------------------------------------+
   //  
   // type - true- ,   
   //+------------------------------------------------------------------+
   void SetGraphType(bool type) {graph_type=type;}
   //+------------------------------------------------------------------+
   //    
   // Engine -  
   //+------------------------------------------------------------------+   
   void SetEngine(DIAGRAM_GRAPH_ENGINES Engine) {engine=Engine;}
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_GRAPH;}
   void CGraphChart(); 
   //+------------------------------------------------------------------+    
};
//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+      
void CGraphChart::CGraphChart() 
{
   ArrayInitialize(edges, -1); 
   nodes_total=edges_total=0; 
   graph_type=true;
   for(int i=0;i<200;i++) nodes[i]="";
   engine=1;
}
//+------------------------------------------------------------------+
// 
// text -  
//:      ,    GetLastError()
// :     ,  -1 
//+------------------------------------------------------------------+
int CGraphChart::AddNode(string text)
{
   for(int i=0;i<200;i++)
      if(nodes[i]=="") {nodes[i]=text; nodes_total++; return i;}
   SetUserError(DIAGRAM_ERR_TOO_MANY_NODES);
   return -1;
}
//+------------------------------------------------------------------+
// 
// Node_A -  1
// Node_B -  2
//:      ,    GetLastError()
// :     ,  -1 
//+------------------------------------------------------------------+
int CGraphChart::AddEdge(int Node_A, int Node_B)
{
   if(Node_A>=200 || Node_B>=200 || Node_A<0 || Node_B<0)
      {SetUserError(DIAGRAM_ERR_INCORRECT_NODE_ID); return -1;}
   if(nodes[Node_A]=="" || nodes[Node_B]=="")
      {SetUserError(DIAGRAM_ERR_INCORRECT_NODE_ID); return -1;}
   for(int i=0;i<400;i++)
      if(edges[i][0]==-1) 
         {edges[i][0]=Node_A; edges[i][1]=Node_B; edges_total++; return i;}
   SetUserError(DIAGRAM_ERR_TOO_MANY_EDGES);
   return -1;
}
//+------------------------------------------------------------------+
//       
// node_ID -  
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CGraphChart::DeleteNode(int node_ID)
{
   if(node_ID>=200 || node_ID<0)
      {SetUserError(DIAGRAM_ERR_INCORRECT_NODE_ID); return false;}
   if(nodes[node_ID]=="")
      {SetUserError(DIAGRAM_ERR_INCORRECT_NODE_ID); return false;}
   for(int i=0;i<400;i++)
      if(edges[i][0]==node_ID || edges[i][1]==node_ID) DeleteEdge(i);
   nodes[node_ID]="";   
   nodes_total--;   
   return true;
}
//+------------------------------------------------------------------+
//  
// edge_ID -  
//:      ,    GetLastError()
// : true-  , -false
//+------------------------------------------------------------------+
bool CGraphChart::DeleteEdge(int edge_ID)
{
   if(edge_ID>=400 || edge_ID<0)
      {SetUserError(DIAGRAM_ERR_INCORRECT_EDGE_ID); return false;}
   if(edges[edge_ID][0]==-1)
      {SetUserError(DIAGRAM_ERR_INCORRECT_EDGE_ID); return false;}
   edges[edge_ID][0]=edges[edge_ID][1]=-1;   
   edges_total--;
   return true;
}
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CGraphChart::CreateRequest()
{
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=gv:");
   switch(engine)
   {
      case 1: {res.Append("dot"); break;}
      case 2: {res.Append("neato"); break;}
      case 3: {res.Append("twopi"); break;}
      case 4: {res.Append("circo"); break;}
      case 5: {res.Append("fdp"); break;}
      default: res.Append("dot");
   }
   ReqSize(res);
   ReqData(res);
   return res.Str();
}
//+------------------------------------------------------------------+
void CGraphChart::ReqData(CString &res)
{
   if(nodes_total==0) return;
   res.Append("&chl=");
   if(graph_type) res.Append("graph{");
   else res.Append("digraph{");
   for(int i=0;i<400;i++)
      if(edges[i][0]>-1 && edges[i][1]>-1)
      {
         res.Append(nodes[edges[i][0]]);
         if(graph_type) res.Append("--");
         else res.Append("->");
         res.Append(nodes[edges[i][1]]+";");
      }
   res.Append("}");
}
//+------------------------------------------------------------------+
//\class CQRCode
//\brief    QR 
//:   CLineXYChart
//+------------------------------------------------------------------+
class CQRCode:public CLineXYChart
{
protected:
   string data;
   int encoding;
   int err;
public:   
   //+------------------------------------------------------------------+
   // ,      
   // Data - 
   //+------------------------------------------------------------------+
   void SetData(string Data) {data=Remove_spaces(Data);}
   //+------------------------------------------------------------------+
   //    
   // err_lvl -  
   //+------------------------------------------------------------------+   
   void SetErrCorrection(DIAGRAM_QRCODE_ERROR_CORRECTION err_lvl) {err=err_lvl;}
   //+------------------------------------------------------------------+
   //   
   // Encoding -  
   //+------------------------------------------------------------------+   
   void SetEncoding(DIAGRAM_QRCODE_ENCODING Encoding) {encoding=Encoding;}
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_QRCODE;}
   ///
   void CQRCode() {data=""; err=1; encoding=1;}    
};
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CQRCode::CreateRequest()
{
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=qr&chl="+data);
   ReqSize(res);
   res.Append("&choe=");
   switch(encoding)
   {
      case 1: {res.Append("UTF-8"); break;}
      case 2: {res.Append("Shift_JIS"); break;}
      case 3: {res.Append("ISO-8859-1"); break;}
      default: res.Append("UTF-8");
   }
   res.Append("&chld=");
   switch(err)
   {
      case 1: {res.Append("L|0"); break;}
      case 2: {res.Append("M|0"); break;}
      case 3: {res.Append("H|0"); break;}
      default: res.Append("L|0");
   }
   return res.Str();
}
//+------------------------------------------------------------------+
//\class CVennChart
//\brief     
//:   CLineXYChart
//+------------------------------------------------------------------+
class CVennChart : public CLineXYChart
{
protected:
   double A_size, B_size, C_size;
   double intAB, intAC, intBC, intABC;   
   color A_color, B_color, C_color;
   string A_label, B_label, C_label;
   void ReqData(CString &res);
   void ReqVennLegend(CString &res);
public:
   //+------------------------------------------------------------------+
   //   
   // A -   
   // B -   
   // C -     
   //:         C=0
   //+------------------------------------------------------------------+
   void SetCircleSizes(double A, double B, double C=0) 
      {A_size=A; B_size=B; C_size=C;}
   //+------------------------------------------------------------------+
   //   
   // A -   
   // B -   
   // C -     
   //+------------------------------------------------------------------+      
   void SetCircleColors(color A, color B, color C) 
      {A_color=A; B_color=B; C_color=C;}  
   //+------------------------------------------------------------------+
   //   
   // AB -  AB
   // AC -  AC
   // BC -  BC 
   // ABC -  ABC    
   //:     .      50,  AB=25 ,       
   //+------------------------------------------------------------------+                   
   void SetIntersections(double AB, double AC, double BC, double ABC)   
      {intAB=AB; intAC=AC; intBC=BC; intABC=ABC;}
   //+------------------------------------------------------------------+
   //   
   // A -   
   // B -   
   // C -     
   //+------------------------------------------------------------------+                  
   void SetVennLegend(string A, string B, string C)
      {A_label=A; B_label=B; C_label=C;}   
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_VENN;}
   void CVennChart();  
};
//+------------------------------------------------------------------+
//
//+------------------------------------------------------------------+
void CVennChart::CVennChart()
{
   A_size=B_size=100; C_size=0;
   A_color=Red; B_color=Green; C_color=Blue;
   A_label="A"; B_label="B"; C_label="C";
   intAB=50; intAC=intBC=intABC=0;
}   
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CVennChart::CreateRequest()
{  
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=v");
   ReqSize(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqFill(res);
   ReqVennLegend(res);
   res.Append("&chd=t:");
   if(C_size>0)
   {
      res.Append(DoubleToString(A_size)+","+DoubleToString(B_size)+","+
          DoubleToString(C_size)+",");
      res.Append(DoubleToString(intAB)+","+DoubleToString(intAC)+","+
         DoubleToString(intBC)+","+DoubleToString(intABC));
   }   
   else
   {
      res.Append(DoubleToString(A_size)+","+DoubleToString(B_size)+",0,");
      res.Append(DoubleToString(intAB));
   }
   res.Append("&chco="); 
   res.Append(GetColorStr(A_color)+","+GetColorStr(B_color)+","+GetColorStr(C_color));    
   return res.Str();
}
//+------------------------------------------------------------------+
void CVennChart::ReqVennLegend(CString &res)
{
   CString legend_str;
   legend_str.Append(A_label+"|"+B_label+"|"+C_label);
   if(legend_position>0)
   {
      res.Append("&chdl=");
      legend_str.TrimRight("|");
      res.Append(GetPointer(legend_str));
      res.Append("&chdlp=");
      switch (legend_position)
      {
         case 1: {res.Append("r"); break;}
         case 2: {res.Append("b"); break;}
         case 3: {res.Append("bv"); break;}
         case 4: {res.Append("t"); break;}
         case 5: {res.Append("tv"); break;}
         case 6: {res.Append("l"); break;}
         default: res.Append("r"); 
      }
   }   
}
//+------------------------------------------------------------------+
//\class CScatterChart
//\brief     
//:   CLineXYChart
//+------------------------------------------------------------------+
class CScatterChart : public CLineXYChart
{
protected:
   void ReqData(CString &res);
   void ReqLineColor(CString &res);
public:
   int AddLineScatter(double &Y_data[], double &X_data[], double &Z_data[], color color_, int digits, string legend);
   int AddLineScatter(CArrayDouble *Y_data, CArrayDouble *X_data, CArrayDouble *Z_data, color color_, int digits, string legend);
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_SCATTER;}   
};
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CScatterChart::CreateRequest()
{
   CString res;
   GetChartMaxMin();
   res.Assign("http://chart.apis.google.com/chart?cht=s");
   ReqSize(res);
   ReqGrid(res);
   ReqAxisLabels(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqData(res);
   ReqLineColor(res);
   ReqLineMarkers(res);
   ReqLineLegend(res);
   ReqLineScaling(res);
   return res.Str();
}
//+------------------------------------------------------------------+
//   
// Y_data -  Y  
// X_data -   
// Z_data - 
// color_ -
// digits -    
// legend -
//:      ,    GetLastError()
//:    - 100
// :    ,  -1
//+------------------------------------------------------------------+
int CScatterChart::AddLineScatter(double &Y_data[], double &X_data[], double &Z_data[], color color_=Red, int digits=8, string legend="")
{
   int id=AddLine(Y_data, X_data, color_, digits, legend); 
   if(id>-1)
   {
      int pos=GetLinePos(id);
      if(ArrayRange(Z_data, 0)==Lines[pos].data_amount)
         Lines[pos].Z_data.AssignArray(Z_data); 
      else
      {
         SetUserError(DIAGRAM_ERR_INCORRECT_DATA_AMOUNT); 
         DeleteLine(id); 
         return-1;
      }   
   } 
   return id;  
}
//+------------------------------------------------------------------+
//   
// Y_data -  Y  
// X_data -   
// Z_data - 
// color_ -
// digits -    
// legend -
//:      ,    GetLastError()
//:    - 100
// :    ,  -1
//+------------------------------------------------------------------+
int CScatterChart::AddLineScatter(CArrayDouble *Y_data, CArrayDouble *X_data, CArrayDouble *Z_data, color color_=Red, int digits=8, string legend="")
{
   int id=AddLine(Y_data, X_data, color_, digits, legend); 
   if(id>-1)
   {
      int pos=GetLinePos(id);
      if(Z_data.Total()==Lines[pos].data_amount)
         Lines[pos].Z_data.AssignArray(Z_data); 
      else
      {
         SetUserError(DIAGRAM_ERR_INCORRECT_DATA_AMOUNT); 
         DeleteLine(id); 
         return-1;
      }   
   } 
   return id;  
}
//+------------------------------------------------------------------+
void CScatterChart::ReqLineColor(CString &res)
{
   if(total_lines>0)
   {
      CString color_str;
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1)
            color_str.Append(GetColorStr(Lines[i].color_)+"|"); 
      res.Append("&chco=");
      color_str.TrimRight("|");
      res.Append(GetPointer(color_str));
   }      
}
//+------------------------------------------------------------------+
void CScatterChart::ReqData(CString &res)
{
   if(total_lines>0)
   {
      CString Xdata, Ydata, Zdata;
      CArrayDouble *data_pointers[100][3];
      int max_data=0;
      int cnt=0;
      res.Append("&chd=t:");
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1) 
            {
            data_pointers[cnt][0]=GetPointer(Lines[i].X_data);
            data_pointers[cnt][1]=GetPointer(Lines[i].Y_data);
            data_pointers[cnt][2]=GetPointer(Lines[i].Z_data);
            if(Lines[i].data_amount>max_data) max_data=Lines[i].data_amount;
            cnt++;
            }
      for(int j=0;j<max_data;j++)
         for(int i=0;i<cnt;i++)
         {
            int pos=GetLinePos(i);
            if(data_pointers[i][0].Total()>j) 
               Xdata.Append(DoubleToString(data_pointers[i][0].At(j), Lines[pos].digits)+",");
            else Xdata.Append("0,");   
            if(data_pointers[i][1].Total()>j) 
               Ydata.Append(DoubleToString(data_pointers[i][1].At(j), Lines[pos].digits)+",");
            else Ydata.Append("0,");   
            if(data_pointers[i][2].Total()>j) 
               Zdata.Append(DoubleToString(data_pointers[i][2].At(j), Lines[pos].digits)+",");               
            else Zdata.Append("0,");   
         }   
      Xdata.TrimRight(",");   
      Ydata.TrimRight(","); 
      Zdata.TrimRight(","); 
      res.Append(GetPointer(Xdata));
      res.Append("|");
      res.Append(GetPointer(Ydata));
      res.Append("|");
      res.Append(GetPointer(Zdata));
   }   
}
//+------------------------------------------------------------------+
//\class CBarChart
//\brief    
//:   CLineXYChart
//+------------------------------------------------------------------+
class CBarChart : public CLineXYChart
{
protected:
   bool grouped;
   double space_bars, space_groups;
   void ReqBarData(CString &res);     
   void ReqLineScaling(CString &res); 
   void ReqAxisLabels(CString &res);
public:
   //+------------------------------------------------------------------+
   //  
   // Grouped - true-, false-
   // Space_between_bars -  
   // Space_between_groups -  
   //+------------------------------------------------------------------+
   void SetGrouped(bool Grouped, double Space_between_bars=4.0/23.0, double Space_between_groups=8.0/23.0)
      {grouped=true; space_bars=Space_between_bars; space_groups=Space_between_groups;}
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_BAR;}       
};
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CBarChart::CreateRequest()
{
   CString res;
   GetChartMaxMin();
   res.Assign("http://chart.apis.google.com/chart?cht=");
   if(grouped) 
   {
      res.Append("bvg&chbh=r,");
      res.Append(DoubleToString(space_bars)+",");
      res.Append(DoubleToString(space_groups));
   }
   else res.Append("bvo&chbh=a");
   ReqSize(res);
   ReqGrid(res);
   ReqAxisLabels(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqBarData(res);
   ReqLineColor(res);
   ReqLineFilling(res);
   ReqLineLabels(res);
   ReqLineLegend(res);
   ReqLineScaling(res);
   return res.Str();
}
//+------------------------------------------------------------------+
void CBarChart::ReqBarData(CString &res)
{
   if(total_lines>0)
   {
      CString data;
      res.Append("&chd=t:");
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1) 
         {
            for(int j=0;j<Lines[i].Y_data.Total();j++)
               data.Append(DoubleToString(Lines[i].Y_data.At(j), Lines[i].digits)+",");
            data.TrimRight(",");    
            data.Append("|");   
         }      
      data.TrimRight("|"); 
      res.Append(GetPointer(data));           
   }
}
//+------------------------------------------------------------------+
void CBarChart::ReqLineScaling(CString &res)
{
   if(total_lines>0)
   {
      res.Append("&chds=");
      if(ymin_val<0) res.Append(DoubleToString(ymin_val)+",");
      else res.Append("0,");
      res.Append(DoubleToString(ymax_val));
   }      
}
//+------------------------------------------------------------------+
void CBarChart::ReqAxisLabels(CString &res)
{
   CString axis_range, axis_types, styles;
   int axe_cnt=0;
   if(bottom_axe_line>-2)
   {
      bottom_axe_index=axe_cnt;
      styles.Append(IntegerToString(bottom_axe_index));
      styles.Append("N*f"+IntegerToString(bottom_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(bottom_axe_color)+",");
      styles.Append(IntegerToString(bottom_axe_size)+",");
      styles.Append("0,lt|");
      //**************************        
      axis_types.Append("x,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(bottom_axe_label!="") {axis_types.Append("x,"); axe_cnt++;}
      axis_range.Append(DoubleToString(xmin_val)+",");
      axis_range.Append(DoubleToString(xmax_val));
      if(bottom_axe_step!=0) 
         axis_range.Append(","+DoubleToString(bottom_axe_step)+"|");
      else axis_range.Append("|");   
   }
   //---
   if(top_axe_line>-2)
   {
      top_axe_index=axe_cnt;
      styles.Append(IntegerToString(top_axe_index));
      styles.Append("N*f"+IntegerToString(top_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(top_axe_color)+",");
      styles.Append(IntegerToString(top_axe_size)+",");
      styles.Append("0,lt|");
      //**************************        
      axis_types.Append("t,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(top_axe_label!="") {axis_types.Append("t,"); axe_cnt++;}
      axis_range.Append(DoubleToString(xmin_val)+",");
      axis_range.Append(DoubleToString(xmax_val));
      if(top_axe_step!=0) 
         axis_range.Append(","+DoubleToString(top_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   if(left_axe_line>-2)
   {
      left_axe_index=axe_cnt;
      styles.Append(IntegerToString(left_axe_index));
      styles.Append("N*f"+IntegerToString(left_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(left_axe_color)+",");
      styles.Append(IntegerToString(left_axe_size)+",");
      styles.Append("0,lt|");
      //**************************        
      axis_types.Append("y,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(left_axe_label!="") {axis_types.Append("y,"); axe_cnt++;}
      if(ymin_val<0) axis_range.Append(DoubleToString(ymin_val)+",");
      else axis_range.Append("0,");
      axis_range.Append(DoubleToString(ymax_val));
      if(left_axe_step!=0) 
         axis_range.Append(","+DoubleToString(left_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   if(right_axe_line>-2)
   {
      right_axe_index=axe_cnt;
      styles.Append(IntegerToString(right_axe_index));
      styles.Append("N*f"+IntegerToString(right_axe_digits)+"zsy*,");
      styles.Append(GetColorStr(right_axe_color)+",");
      styles.Append(IntegerToString(right_axe_size)+",");
      styles.Append("0,lt|");
      //**************************      
      axis_types.Append("r,");
      axis_range.Append(IntegerToString(axe_cnt++)+",");
      if(right_axe_label!="") {axis_types.Append("r,"); axe_cnt++;}
      if(ymin_val<0) axis_range.Append(DoubleToString(ymin_val)+",");
      else axis_range.Append("0,");
      axis_range.Append(DoubleToString(ymax_val));
      if(right_axe_step!=0) 
         axis_range.Append(","+DoubleToString(right_axe_step)+"|");
      else axis_range.Append("|");    
   }
   //---
   res.Append("&chxt=");
   axis_types.TrimRight(",");
   res.Append(GetPointer(axis_types));
   res.Append("&chxr=");
   axis_range.TrimRight("|");
   res.Append(GetPointer(axis_range));
   //---
   CString labels, positions;
   if(bottom_axe_index>-1 && bottom_axe_label!="")
   {
      styles.Append(IntegerToString(bottom_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");
      labels.Append(IntegerToString(bottom_axe_index+1)+":|"+bottom_axe_label+"|");
      positions.Append(IntegerToString(bottom_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(top_axe_index>-1 && top_axe_label!="")
   {
      styles.Append(IntegerToString(top_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");   
      labels.Append(IntegerToString(top_axe_index+1)+":|"+top_axe_label+"|");
      positions.Append(IntegerToString(top_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(left_axe_index>-1 && left_axe_label!="")
   {
      styles.Append(IntegerToString(left_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");
      labels.Append(IntegerToString(left_axe_index+1)+":|"+left_axe_label+"|");
      positions.Append(IntegerToString(left_axe_index+1)+","+IntegerToString(50)+"|");
   }   
   if(right_axe_index>-1 && right_axe_label!="")
   {
      styles.Append(IntegerToString(right_axe_index+1)+",");
      styles.Append(GetColorStr(axe_label_color)+",");
      styles.Append(IntegerToString(axe_label_size)+",");
      styles.Append("0,lt|");   
      labels.Append(IntegerToString(right_axe_index+1)+":|"+right_axe_label+"|");
      positions.Append(IntegerToString(right_axe_index+1)+","+IntegerToString(50)+"|");
   }       
   //---
   labels.TrimRight("|");
   positions.TrimRight("|");
   res.Append("&chxl=");
   res.Append(GetPointer(labels));   
   res.Append("&chxp=");
   res.Append(GetPointer(positions));   
   res.Append("&chxs=");
   res.Append(GetPointer(styles));   
}
//+------------------------------------------------------------------+
//\class CPieChart
//\brief     
//:   CLineXYChart
//+------------------------------------------------------------------+
class CPieChart : public CLineXYChart
{
protected:
   bool ptype;
   bool labels;
   double rotation;
   void ReqPieLabels(CString &res);
   void ReqPieData(CString &res);
public:
   int AddPieSlice(double Data, int dimensional, color color_, int digits, string label);
   //+------------------------------------------------------------------+
   //   
   // type - true-, false-
   //:      ,   
   //+------------------------------------------------------------------+
   void SetPieType(bool type) {ptype=type;}
   //+------------------------------------------------------------------+
   ///   
   // set - true-, false-
   //:       .       ,      
   //+------------------------------------------------------------------+   
   void SetPieLabels(bool set) {labels=set;}
   //+------------------------------------------------------------------+
   //   
   // val -  
   //+------------------------------------------------------------------+   
   void SetPieRotation(double val) {rotation=val;}
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_PIE;}      
   //+------------------------------------------------------------------+ 
};
//+------------------------------------------------------------------+
//   
// Data -  
// dimensional - ,     
// color_ - 
// digits -    
// legend - 
//:      ,    GetLastError()
// :    ,  -1
//+------------------------------------------------------------------+
int CPieChart::AddPieSlice(double Data, int dimensional=0, color color_=Red, int digits=8, string legend="")
{
   double Y_data[1];
   Y_data[0]=Data;
   int id=AddLine(Y_data, color_, digits, legend); 
   if(id>-1)
   {
      int pos=GetLinePos(id);
      Lines[pos].dimensional=dimensional; 
   } 
   return id;  
}
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CPieChart::CreateRequest()
{
   CString res;
   GetChartMaxMin();
   res.Assign("http://chart.apis.google.com/chart?cht=");
   bool flag=true;
   for(int i=0;i<100;i++)
      if(Lines[i].ID>-1 && Lines[i].dimensional>0) {flag=false; break;}
   if(flag)
   {
      if(ptype) res.Append("p");
      else res.Append("p3");
   }
   else res.Append("pc");   
   res.Append("&chp="+DoubleToString(rotation));
   ReqSize(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqPieData(res);
   ReqLineColor(res);
   ReqLineLegend(res);
   ReqPieLabels(res);
   return res.Str();
}
//+------------------------------------------------------------------+
void CPieChart::ReqPieLabels(CString &res)
{
   if(total_lines>0 && labels)
   {
      CString data;
      res.Append("&chl=");
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1) 
            data.Append(Lines[i].legend+"|"); 
      data.TrimRight("|"); 
      res.Append(GetPointer(data));           
   }
}
//+------------------------------------------------------------------+
void CPieChart::ReqPieData(CString &res)
{
   if(total_lines>0)
   {
      CString data[100], dat;
      res.Append("&chd=t:");
      for(int i=0;i<100;i++)
         if(Lines[i].ID>-1) 
            data[Lines[i].dimensional].Append(DoubleToString(Lines[i].Y_data.At(0), Lines[i].digits)+",");
      for(int i=0;i<100;i++)
      {
         data[i].TrimRight(",");    
         data[i].Append("|");   
         dat.Append(GetPointer(data[i]));
      }      
      dat.TrimRight("|"); 
      res.Append(GetPointer(dat));           
   }
}
//+------------------------------------------------------------------+
//\class CRadarChart
//\brief     
//:   CLineXYChart
//+------------------------------------------------------------------+
class CRadarChart : public CLineXYChart
{

public:
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_RADAR;}   
   //+------------------------------------------------------------------+  
};
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CRadarChart::CreateRequest()
{
   GetChartMaxMin();
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=rs");
   ReqSize(res);
   ReqGrid(res);
   ReqAxisLabels(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqLineData(res);
   ReqLineColor(res);
   ReqLineStyle(res);
   ReqLineMarkers(res);
   ReqLineFilling(res);
   ReqLineLabels(res);
   ReqLineLegend(res);
   ReqLineScaling(res);
   return res.Str();
}
//+------------------------------------------------------------------+
//\class CCandleChart
//\brief      
//:   CLineXYChart
//+------------------------------------------------------------------+
class CCandleChart : public CLineXYChart
{
protected:
   int candle_size;
   void ReqData(CString &res);
   void ReqParams(CString &res);
   void GetChartMaxMin();
   void Transform(CArrayDouble &data);
public:
   int AddCandles(double &Open[], double &Close[], double &High[], double &Low[], 
      color ColorBear=Black); 
   int AddCandles(CArrayDouble &Open, CArrayDouble &Close, CArrayDouble &High, CArrayDouble &Low, 
      color ColorBear=Black); 
   //+------------------------------------------------------------------+
   //    
   // size - 
   //:  size=0    
   //+------------------------------------------------------------------+            
   void SetCandleSize(int size) {candle_size=size;}   
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_CANDLESTRICK;}   
   //+------------------------------------------------------------------+   
};
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CCandleChart::CreateRequest()
{
   GetChartMaxMin();
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=lc");
   ReqSize(res);
   ReqGrid(res);
   ReqAxisLabels(res);
   ReqFill(res);
   ReqTitle(res);
   ReqMargins(res);
   ReqData(res);
   ReqParams(res);
   return res.Str();
}
//+------------------------------------------------------------------+
void CCandleChart::ReqParams(CString &res)
{
   if(total_lines>0)
   {
      res.Append("&chm=F,"+GetColorStr(Lines[0].color_)+",0,-1,");
      if(candle_size>0) res.Append(IntegerToString(candle_size));
      else
      {
         int total_size=margin_left+margin_right+X;
         res.Append(IntegerToString(total_size/(Lines[0].data_amount+4)));
      }
   }
}
//+------------------------------------------------------------------+
//   
// Open -  
// Close -  
// High -  
// Low -  
// ColorBear -   
//:      ,    GetLastError()
//:       
// :     ,  -1
//+------------------------------------------------------------------+
int CCandleChart::AddCandles(double &Open[], double &Close[], double &High[], double &Low[], 
   color ColorBear=Black)
{
   int o_range=ArrayRange(Open, 0);
   int c_range=ArrayRange(Close, 0);
   int h_range=ArrayRange(High, 0);
   int l_range=ArrayRange(Low, 0);
   if(o_range!=c_range || o_range!=h_range || o_range!=l_range)
      {SetUserError(DIAGRAM_ERR_INCORRECT_DATA_AMOUNT); return -1;}
   Lines[0].X_data.AssignArray(Open);
   Lines[0].Y_data.AssignArray(Close);
   Lines[0].Z_data.AssignArray(Low);
   Lines[0].H_data.AssignArray(High);
   Lines[0].ID=0;
   Lines[0].color_=ColorBear;
   Lines[0].digits=4;
   Lines[0].legend="";
   Lines[0].data_amount=o_range;
   total_lines=1;
   return 0;
}
//+------------------------------------------------------------------+
//   
// Open -  
// Close -  
// High -  
// Low -  
// ColorBear -   
//:      ,    GetLastError()
//:       
// :     ,  -1
//+------------------------------------------------------------------+
int CCandleChart::AddCandles(CArrayDouble &Open, CArrayDouble &Close, CArrayDouble &High, CArrayDouble &Low, 
   color ColorBear=Black)
{
   int o_range=Open.Total();
   int c_range=Close.Total();
   int h_range=High.Total();
   int l_range=Low.Total();
   if(o_range!=c_range || o_range!=h_range || o_range!=l_range)
      {SetUserError(DIAGRAM_ERR_INCORRECT_DATA_AMOUNT); return -1;}
   Lines[0].X_data.AssignArray(GetPointer(Open));
   Lines[0].Y_data.AssignArray(GetPointer(Close));
   Lines[0].Z_data.AssignArray(GetPointer(Low));
   Lines[0].H_data.AssignArray(GetPointer(High));
   Lines[0].ID=0;
   Lines[0].color_=ColorBear;
   Lines[0].digits=8;
   Lines[0].legend="";
   Lines[0].data_amount=o_range;
   total_lines=1;
   return 0;   
}   
//+------------------------------------------------------------------+   
void CCandleChart::Transform(CArrayDouble &data)
{
   if(data.Total()==0) return;
   for(int i=0;i<data.Total();i++)
      data.Update(i, ((data.At(i)-ymin_val)/(ymax_val-ymin_val))*100.0);
}
//+------------------------------------------------------------------+
void CCandleChart::ReqData(CString &res)
{
   if(total_lines>0)
   {
      //****************
      CArrayDouble tmpO, tmpC, tmpH, tmpL;
      tmpO.AssignArray(GetPointer(Lines[0].X_data));
      tmpC.AssignArray(GetPointer(Lines[0].Y_data));
      tmpH.AssignArray(GetPointer(Lines[0].Z_data));
      tmpL.AssignArray(GetPointer(Lines[0].H_data));
      Transform(tmpO);
      Transform(tmpC);
      Transform(tmpH);
      Transform(tmpL);
      //****************
      CString data_str;
      CString odata_str, cdata_str, hdata_str, ldata_str;
      odata_str.Assign("-1,");
      cdata_str.Assign("-1,");
      hdata_str.Assign("-1,");
      ldata_str.Assign("-1,");
      for(int j=0;j<Lines[0].data_amount;j++)
      {
         odata_str.Append(DoubleToString(tmpO.At(j),3)+",");
         cdata_str.Append(DoubleToString(tmpC.At(j),3)+",");
         ldata_str.Append(DoubleToString(tmpL.At(j),3)+",");
         hdata_str.Append(DoubleToString(tmpH.At(j),3)+",");         
      }  
      odata_str.Append("-1");
      cdata_str.Append("-1");
      hdata_str.Append("-1");
      ldata_str.Append("-1");    
      data_str.Append(GetPointer(ldata_str)); 
      data_str.Append("|"); 
      data_str.Append(GetPointer(odata_str));
      data_str.Append("|");  
      data_str.Append(GetPointer(cdata_str)); 
      data_str.Append("|"); 
      data_str.Append(GetPointer(hdata_str));
      data_str.Append("|");        
      res.Append("&chd=t0:");
      data_str.TrimRight("|");
      res.Append(GetPointer(data_str));       
    }     
   
}
//+------------------------------------------------------------------+
void CCandleChart::GetChartMaxMin()
{
   if(total_lines>0) 
   {
      Lines[0].x_max=Lines[0].data_amount+2; Lines[0].x_min=1;
      Lines[0].y_max=DBL_MIN; Lines[0].y_min=DBL_MAX;
      for(int j=0;j<Lines[0].Z_data.Total();j++)
      {
         if(Lines[0].Z_data.At(j)<Lines[0].y_min) Lines[0].y_min=Lines[0].Z_data.At(j);
      }
      for(int j=0;j<Lines[0].H_data.Total();j++)
      {
         if(Lines[0].H_data.At(j)>Lines[0].y_max) Lines[0].y_max=Lines[0].H_data.At(j);
      }     
   }   
   Lines[0].y_max=Lines[0].y_max+(Lines[0].y_max-Lines[0].y_min)*Lines[0].stretch/100.0;    
   Lines[0].y_min=Lines[0].y_min-(Lines[0].y_max-Lines[0].y_min)*Lines[0].stretch/100.0; 
   xmax_val=Lines[0].x_max; xmin_val=Lines[0].x_min;
   ymax_val=Lines[0].y_max; ymin_val=Lines[0].y_min;
}
//+------------------------------------------------------------------+
//\class CMapChart
//\brief    
//:   CLineXYChart
//+------------------------------------------------------------------+
class CMapChart : public CLineXYChart
{
protected:
   int zoom;
   string data;
   color color1, color2, color3;
   void ReqColor(CString &res);
public:
   //+------------------------------------------------------------------+
   // () 
   // zoom_area - 
   //+------------------------------------------------------------------+
   void SetZoomArea(DIAGRAM_MAP_AREA zoom_area) {zoom=zoom_area;}
   //+------------------------------------------------------------------+
   //           ISO 3166-1-alpha-2
   // country_codes -   
   //:       <a href="http://www.iso.org/iso/english_country_names_and_code_elements"></a>
   //+------------------------------------------------------------------+   
   void SetCountries(string country_codes) {data=country_codes;}
   //+------------------------------------------------------------------+
   //    
   // default_ -    
   // start_gradient -     
   // end_gradient -     
   //+------------------------------------------------------------------+
   void SetColors(color default_=White, color start_gradient=Blue, color end_gradient=Blue)
      {color1=default_; color2=start_gradient; color3=end_gradient;}   
   string CreateRequest();
   //+------------------------------------------------------------------+
   //    
   // :        
   //+------------------------------------------------------------------+         
   DIAGRAM_TYPE Type() {return DIAGRAM_TYPE_MAP;}
   void CMapChart();
};
//+------------------------------------------------------------------+
void CMapChart::CMapChart()
{
   color1=White;
   color2=Blue;
   color3=Red;
   data="";
   zoom=0;
}
//+------------------------------------------------------------------+
void CMapChart::ReqColor(CString &res)
{
   res.Append("&chco="+GetColorStr(color1)+","+GetColorStr(color2)+","+
      GetColorStr(color3));
}
//+------------------------------------------------------------------+
//    Google
// :  
//+------------------------------------------------------------------+
string CMapChart::CreateRequest()
{
   CString res;
   res.Assign("http://chart.apis.google.com/chart?cht=t&chld="+data);
   res.Append("&chtm=");
   switch(zoom)
   {
      case DIAGRAM_MAP_AREA_WORLD: {res.Append("world"); break;}
      case DIAGRAM_MAP_AREA_AFRICA: {res.Append("africa"); break;}
      case DIAGRAM_MAP_AREA_ASIA: {res.Append("asia"); break;}
      case DIAGRAM_MAP_AREA_EUROPE: {res.Append("europe"); break;}
      case DIAGRAM_MAP_AREA_MIDDLE_EAST: {res.Append("middle_east"); break;}
      case DIAGRAM_MAP_AREA_SOUTH_AMERICA: {res.Append("south_america"); break;}
      case DIAGRAM_MAP_AREA_USA: {res.Append("usa"); break;}
      default: res.Append("world"); 
   }
   res.Append("&chd=t:");
   int w=100/(StringLen(data)/2);
   int w0=w;
   for(int i=0;i<StringLen(data)/2;i++)
      {res.Append(IntegerToString(w0)+",");w0+=w;}
   res.TrimRight(",");   
   if(X>440) X=440;//  
   if(Y>220) Y=220;//    
   ReqSize(res);
   ReqFill(res);
   ReqTitle(res);
   ReqColor(res);
   ReqMargins(res);
   return res.Str();
}